Imports System.Net
Imports System.IO

Public Class ImportDlg

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click


        Me.Enabled = False

        Try

            Dim oDoc As New Xml.XmlDocument()

            Dim strDesc As String = Now.ToString
            If txtDescription.Text.Trim.Length > 0 Then
                strDesc = txtDescription.Text.Trim
            End If

            Dim strXML As String = "<List><DI FormName=""" + txtAppName.Text + """ Description=""" + strDesc + """ User=""" + txtAssignee.Text + """"
            strXML += " Action=""" + cbAction.Text + """"
            If (cbAction.Text = "Update") And (txtOriginal.Text.Trim.Length > 0) Then
                strXML += " OriginalDescription=""" + txtOriginal.Text.Trim + """"
            End If

            strXML += " >"

            'add the XML for each item we are going to import
            If (cbAction.Text <> "Delete") Then
                If (txtLabel1.Text.Length > 0) And (txtValue1.Text.Length > 0) Then
                    strXML += "<DIEntry Label=""" + txtLabel1.Text + """ Value=""" + txtValue1.Text + """/>"
                End If
                If (txtLabel2.Text.Length > 0) And (txtValue2.Text.Length > 0) Then

                    strXML += "<DIEntry Label=""" + txtLabel2.Text + """ Value=""" + txtValue2.Text + """/>"
                End If

                If (txtLabel3.Text.Length > 0) And (txtValue3.Text.Length > 0) Then
                    strXML += "<DIEntry Label=""" + txtLabel3.Text + """ Value=""" + txtValue3.Text + """/>"
                End If

            End If

            strXML += "</DI>"
            strXML += "</List>"

            oDoc.LoadXml(strXML)

            Dim strURL As String = APIHelper.GetDispatchImportURL(txtServer.Text.Trim, txtUsername.Text.Trim, txtPassword.Text.Trim)

            Dim strResults As String = ExecuteURL(strURL, oDoc.OuterXml)

            Dim oResults As New Xml.XmlDocument
            oResults.LoadXml(strResults)

            Dim oErrorNode As Xml.XmlNode = oResults.SelectSingleNode("CanvasResult/Error")

            If Not IsNothing(oErrorNode) Then
                Dim strErrorCode As String = oErrorNode.SelectSingleNode("ErrorCode").InnerText
                Dim strErrorDesc As String = oErrorNode.SelectSingleNode("Description").InnerText
                If String.Compare("0", strErrorCode, True) <> 0 Then
                    MessageBox.Show("Error Occurred: " + strErrorCode + " - " + strErrorDesc)
                End If
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        Me.Enabled = True

    End Sub


    Private Function ExecuteURL(ByVal URL As String, ByVal postData As String, Optional ByVal BinaryRead As Boolean = False) As Object

        URL = URL.Replace(" ", "%20")
        Dim retObject As Object

        Try

            Dim request As HttpWebRequest = CType(WebRequest.Create(URL), HttpWebRequest)

            'setProxySettings(request)

            Dim byteArray As Byte() = System.Text.Encoding.UTF8.GetBytes(postData)

            request.ContentType = "application/xml"
            request.ContentLength = byteArray.Length
            'request.Timeout = 4000
            request.Method = "POST"

            Dim postStream As Stream = request.GetRequestStream
            postStream.Write(byteArray, 0, byteArray.Length)
            postStream.Close()

            Dim response As HttpWebResponse

            Try

                response = CType(request.GetResponse(), HttpWebResponse)
                Dim streamResponse As Stream = response.GetResponseStream()

                Select Case (response.StatusCode)
                    Case System.Net.HttpStatusCode.OK, System.Net.HttpStatusCode.Created

                        'read the content from the response

                        If BinaryRead Then

                            Dim aByte() As Byte
                            aByte = New Byte(4096) {}
                            Dim oMS As New IO.MemoryStream
                            Dim count As Int32 = -1
                            While count <> 0
                                count = streamResponse.Read(aByte, 0, aByte.Length)
                                oMS.Write(aByte, 0, count)
                            End While

                            retObject = oMS

                        Else

                            Dim streamRead As StreamReader = New StreamReader(streamResponse)
                            retObject = streamRead.ReadToEnd
                            streamRead.Close()

                        End If

                    Case System.Net.HttpStatusCode.Redirect, System.Net.HttpStatusCode.MovedPermanently
                        MessageBox.Show(String.Format( _
                            "Unable to read response content.  URL has moved. StatusCode={0}.", _
                            response.StatusCode), "Web Exception")
                    Case System.Net.HttpStatusCode.NotFound
                        MessageBox.Show(String.Format( _
                            "Unable to read response content. URL not found. StatusCode={0}.", _
                            response.StatusCode), "Web Exception")
                    Case Else
                        MessageBox.Show(String.Format( _
                            "Unable to read response content. StatusCode={0}.", _
                            response.StatusCode), "Web Exception")
                End Select
            Catch we As System.Net.WebException
                'If (we.Status = Net.WebExceptionStatus.Timeout) Then
                '    Return False
                'End If
                MessageBox.Show(we.Message)
                MessageBox.Show("Unable to contact server.", "Communication Error")
            Finally
                If (Not IsNothing(response)) Then
                    response.Close()
                End If
            End Try

        Catch ex As Exception
            MessageBox.Show(ex.Message)
            MessageBox.Show("Unable to contact server.", "Communication Error")
        End Try

        Return retObject

    End Function

End Class
