Public Class APIHelper

    Public Class Constants
        Public Class Parameters
            Public Class FormsRequest
                Public Const NAME As String = "name"
                Public Const SEARCH_NAME As String = "search_name"
            End Class
            Public Class ImagesRequest
                Public Const IMAGE_ID As String = "image_id"
            End Class

            Public Class SubmissionRequest
                Public Const FORM_NAME As String = "form_name"
                Public Const SEARCH_NAME As String = "search_form_name"
                Public Const FORM_ID As String = "form_id"
                Public Const BEGIN_DATE As String = "begin_date"
                Public Const END_DATE As String = "end_date"
                Public Const BEGIN_SEC As String = "begin_sec"
                Public Const END_SEC As String = "end_sec"
                Public Const PAGE As String = "page"
            End Class

        End Class
    End Class

    Public Shared Function GetFormsRequestURL(ByVal ServerName As String, ByVal Username As String, ByVal Password As String) As String
        Dim strURL = "http://" + ServerName + "/apiv2/forms.xml"
        strURL += GetQuerySringParameter("username", Username, True)
        strURL += GetQuerySringParameter("password", Password)
        Return strURL
    End Function

    Public Shared Function GetImagesRequestURL(ByVal ServerName As String, ByVal Username As String, ByVal Password As String) As String
        Dim strURL = "http://" + ServerName + "/apiv2/images.xml"
        strURL += GetQuerySringParameter("username", Username, True)
        strURL += GetQuerySringParameter("password", Password)
        Return strURL
    End Function

    Public Shared Function GetSubmissionsRequestURL(ByVal ServerName As String, ByVal Username As String, ByVal Password As String) As String
        Dim strURL = "https://" + ServerName + "/apiv2/submissions.xml"
        strURL += GetQuerySringParameter("username", Username, True)
        strURL += GetQuerySringParameter("password", Password)
        Return strURL

    End Function

    Public Shared Function GetCSVRequestURL(ByVal ServerName As String, ByVal Username As String, ByVal Password As String) As String
        Dim strURL = "https://" + ServerName + "/apiv2/csv.xml"
        strURL += GetQuerySringParameter("username", Username, True)
        strURL += GetQuerySringParameter("password", Password)
        Return strURL

    End Function

    Public Shared Function GetQuerySringParameter(ByVal Name As String, ByVal Value As String, Optional ByVal FirstParameter As Boolean = False) As String
        Dim strParmString = ""
        If FirstParameter Then
            strParmString += "?"
        Else
            strParmString += "&"
        End If

        strParmString += Name + "=" + Value

        Return strParmString

    End Function

End Class
