Imports CanvasIntegrationSample.ResultsObjects

Public Class ResultsDlg

    Public Sub New(ByVal Submission As CanvasSubmission)

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        PopulateTree(Submission)

    End Sub

    Private Sub PopulateTree(ByVal Submission As CanvasSubmission)

        For Each oSec As CanvasSection In Submission.Sections

            Dim oSecNode As TreeNode = CreateSectionNode(oSec)
            Me.treeResults.Nodes.Add(oSecNode)

        Next

        treeResults.ExpandAll()

    End Sub

    Private Function CreateSectionNode(ByVal Section As CanvasSection) As TreeNode
        Dim tNode As New TreeNode()
        tNode.Text = Section.Name

        For Each oScreen As CanvasScreen In Section.Screens

            Dim oScreenNode As TreeNode = CreateScreenNode(oScreen)
            tNode.Nodes.Add(oScreenNode)

        Next

        Return tNode

    End Function

    Private Function CreateScreenNode(ByVal Screen As CanvasScreen) As TreeNode
        Dim tNode As New TreeNode()
        tNode.Text = Screen.Name

        For Each oResp As CanvasResponse In Screen.Responses

            tNode.Nodes.Add(CreateResponseNode(oResp))

        Next

        For Each oGroup As CanvasResponseGroup In Screen.ResponseGroups
            'Create Key Node
            Dim oGroupNode As TreeNode = CreateResponseNode(oGroup.KeyReponse)

            ' Add response sub nodes to key node
            oGroupNode.Nodes.Add(CreateSectionNode(oGroup.Section))

            tNode.Nodes.Add(oGroupNode)

        Next

        Return tNode

    End Function

    Private Function CreateResponseNode(ByVal Response As CanvasResponse) As TreeNode
        Dim tNode As New TreeNode()
        tNode.Text = Response.Label + " : " + Response.Value
        Return tNode
    End Function


End Class